#ifndef DAA_H
#define DAA_H

/*
 *==============================================================================
 * File: daa.h
 *
 * VERSION:
 *
 * Description:
 *     header file for daa.c - dynamic array allocator
 *
 * Modified:    By:             What:
 *==============================================================================
 */

/*
 *=================================================================*
 *                                                                 *
 *   (c) Copyright, 2001 Massachusetts Institute of Technology.    *
 *       This material may be reproduced by or for the             *
 *       U.S. Government pursuant to the copyright license         *
 *       under the clause at 252.227-7013 (June, 1995).            *
 *                                                                 *
 *=================================================================*
 */

/*
 *------------------------------------------------------------------------------
 * include files
 *------------------------------------------------------------------------------
 */

#include <thread.h>
#include <synch.h>

/*
 *------------------------------------------------------------------------------
 * constants
 *------------------------------------------------------------------------------
 */

/*
 *------------------------------------------------------------------------------
 * data types
 *------------------------------------------------------------------------------
 */

/*
 *------------------------------------------------------------------------------
 * global variables
 *------------------------------------------------------------------------------
 */

extern char *daa_errs[];

/*
 *------------------------------------------------------------------------------
 * function prototypes
 *------------------------------------------------------------------------------
 */

int
das(int data_size, int num_dim,
    int *dim, int *err_code);

void *
daa(int data_size, int num_dim, int *dim, int *st,
    int *err_code, char *base_ptr, char *init_ptr);

void *
daav(int data_size, int num_dim, int *dim, int *st,
    int *err_code, char **free_ptr, char *init_ptr);

#endif /* !DAA_H */

